library BDEUtil;

{ Important note about DLL memory management: ShareMem must be the
  first unit in your library's USES clause AND your project's (select
  Project-View Source) USES clause if your DLL exports any procedures or
  functions that pass strings as parameters or function results. This
  applies to all strings passed to and from your DLL--even those that
  are nested in records and classes. ShareMem is the interface unit to
  the BORLNDMM.DLL shared memory manager, which must be deployed along
  with your DLL. To avoid using BORLNDMM.DLL, pass string information
  using PChar or ShortString parameters. }

uses
  ShareMem,
  SysUtils,
  Classes,
  PlugMan,
  Forms,
  DBTables,
  FBDEUtil in 'FBDEUtil.pas' {FormBDEUtil};

{$E ODL}

{$R *.RES}
{$R PlugImg.RES}

Var
  Linker: TPlugInLinker;


Procedure LinkerOnFormCreate(HostApp: TApplication; HostSes: TSession; Var Form: TPlugInForm); StdCall;
Begin
  Application := HostApp;
  //Session := HostSes;
  FormBDEUtil := TFormBDEUtil.Create(HostApp);
  Form := FormBDEUtil;
End;

Procedure LinkerOnFinalize(BackApp: TApplication; BackSes: TSession); StdCall;
Begin
  //Session := BackSes;
  Application := BackApp;
End;


// ************* Exported Procedures ******************

Procedure GetPlugInInfo(Var N, D, I: String); StdCall;
Begin
  // Remember to set PlugIn Property
  N := 'BDE Utility';
  D := 'Maintenance Utility PlugIn for BDE';
  I := 'Developed by Easy Target';
End;

Function StartPlugIn: TPlugInLinker; StdCall;
Begin
  Linker := TPlugInLinker.Create;
  Linker.BackApplic := Application;
  Linker.BackSess := Session;
  Linker.FormCreateProc := LinkerOnFormCreate;
  Linker.FinalizeProc := LinkerOnFinalize;

  // Remember to set Form Property
  Linker.FormStyle := fsNormal;
  Linker.IsModal := True;
  Linker.Multiple := False;
  Linker.CanUnload := True; // If Session has been changed, Plugin can't be unloaded

  Result := Linker;
End;

Procedure StopPlugIn; StdCall;
Begin
  If Assigned(Linker) Then Linker.Free;
End;

Procedure Execute; StdCall;  // Funzione per utilizzo non "PlugIn"
Begin
  FormBDEUtil := TFormBDEUtil.Create(Nil);
  FormBDEUtil.ShowModal;
  FormBDEUtil.Free;
End;

Exports
  GetPlugInInfo Index 1,
  StartPlugIn   Index 2,
  StopPlugIn    Index 3,
  Execute       Index 4;

begin
end.
