unit FormMDI;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Db, DBTables, PlugMan, Grids, DBGrids, Buttons;

type
  TFormVDBPlugInMDI = class(TPlugInForm)
    PanelTop: TPanel;
    PanelClient: TPanel;
    DataSource: TDataSource;
    CBDataBase: TComboBox;
    Label1: TLabel;
    CBTabella: TComboBox;
    Label2: TLabel;
    BtnOpen: TSpeedButton;
    Query: TQuery;
    DBGrid: TDBGrid;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure CBDataBaseChange(Sender: TObject);
    procedure BtnOpenClick(Sender: TObject);
  private
  public
    Procedure Init(Linker: TPlugInLinker); Override;
  end;

Var
  FormVDBPlugInMDI: TFormVDBPlugInMDI;

implementation

{$R *.DFM}

Procedure TFormVDBPlugInMDI.Init(Linker: TPlugInLinker);
Begin
  Inherited;
  Session.GetAliasNames(CBDataBase.Items);
End;

procedure TFormVDBPlugInMDI.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  FLinker.FormClosed(Self);
  Action := caFree;
end;

procedure TFormVDBPlugInMDI.CBDataBaseChange(Sender: TObject);
begin
  If CBDataBase.ItemIndex < 0 Then Exit;
  Session.GetTableNames(CBDataBase.Items[CBDataBase.ItemIndex], '*.*', True, False, CBTabella.Items);
end;

procedure TFormVDBPlugInMDI.BtnOpenClick(Sender: TObject);
begin
  If CBDataBase.ItemIndex < 0 Then Exit;
  If CBTabella.ItemIndex < 0 Then Exit;
  With EnhQuery Do
  Begin
    Close;
    DataBaseName := CBDataBase.Items[CBDataBase.ItemIndex];
    SQL.Text := 'SELECT * FROM ' + CBTabella.Items[CBTabella.ItemIndex];
    Open;
  End;
  If EnhQuery.Active Then
    NotifyLinker('OPEN', Null);
end;

end.
