library PlugMDI;

{ Important note about DLL memory management: ShareMem must be the
  first unit in your library's USES clause AND your project's (select
  Project-View Source) USES clause if your DLL exports any procedures or
  functions that pass strings as parameters or function results. This
  applies to all strings passed to and from your DLL--even those that
  are nested in records and classes. ShareMem is the interface unit to
  the BORLNDMM.DLL shared memory manager, which must be deployed along
  with your DLL. To avoid using BORLNDMM.DLL, pass string information
  using PChar or ShortString parameters. }

uses
  ShareMem,
  SysUtils,
  Classes,
  PlugMan,
  Forms,
  DBTables,
  FormMDI in 'FormMDI.pas' {FormVDBPlugInMDI};

{$E ODL}

{$R *.RES}
{$R PlugImg.RES}

Var
  Linker: TPlugInLinker;


Procedure LinkerOnFormCreate(HostApp: TApplication; HostSes: TSession; Var Form: TPlugInForm); StdCall;
Var
  Child: TFormVDBPlugInMDI;
Begin
  Application := HostApp;
  Session := HostSes;
  Child := TFormVDBPlugInMDI.Create(HostApp);
  Form := Child;
End;

Procedure LinkerOnFinalize(BackApp: TApplication; BackSes: TSession); StdCall;
Begin
  Session := BackSes;
  Application := BackApp;
End;


// ************* Exported Procedures ******************

Procedure GetPlugInInfo(Var N, D, I: String); StdCall;
Begin
  // Remember to set PlugIn Property
  N := 'PlugIn MDI Child';
  D := 'This is the PlugIn Tamplate for MDI PlugIns';
  I := 'Developed by Easy Target';
End;

Function StartPlugIn: TPlugInLinker; StdCall;
Begin
  Linker := TPlugInLinker.Create;
  Linker.BackApplic := Application;
  Linker.BackSess := Session;
  Linker.FormCreateProc := LinkerOnFormCreate;
  Linker.FinalizeProc := LinkerOnFinalize;

  // Remember to set Form Property
  Linker.FormStyle := fsMDIChild;
  Linker.IsModal := False;
  Linker.Multiple := True;
  Linker.CanUnload := False;  // If Session has been changed, Plugin can't be unloaded

  Result := Linker;
End;

Procedure StopPlugIn; StdCall;
Begin
  If Assigned(Linker) Then Linker.Free;
End;

Exports
  GetPlugInInfo Index 1,
  StartPlugIn   Index 2,
  StopPlugIn    Index 3;

begin
end.
